#pragma clang diagnostic ignored "-Wmissing-prototypes"
#include <metal_stdlib>
#include <simd/simd.h>
#include "required2.metal"
#include "std2_texture.metal"
#include "std2_vs.metal"
using namespace metal;
//SG_REFLECTION_BEGIN(100)
//output vec4 fragColor 0
//sampler sampler depthTextureSmp 2:10
//texture texture2D depthTexture 2:2:2:10
//ubo float UserUniforms 2:16:8 {
//float2 clipPlanes 0
//}
//SG_REFLECTION_END

namespace SNAP_VS {
struct userUniformsObj
{
float2 clipPlanes;
};
struct sc_Set2
{
texture2d<float> depthTexture [[id(2)]];
sampler depthTextureSmp [[id(10)]];
constant userUniformsObj* UserUniforms [[id(16)]];
};
struct sc_VertOut
{
sc_SysOut sc_sysOut;
};
struct sc_VertIn
{
sc_SysAttributes sc_sysAttributes;
};
vertex sc_VertOut main_vert(sc_VertIn sc_vertIn [[stage_in]],constant sc_Set0& sc_set0 [[buffer(0)]],constant sc_Set1& sc_set1 [[buffer(1)]],constant sc_Set2& sc_set2 [[buffer(2)]],uint gl_VertexIndex [[vertex_id]],uint gl_InstanceIndex [[instance_id]])
{
sc_SysIn sc_sysIn;
sc_sysIn.sc_sysAttributes=sc_vertIn.sc_sysAttributes;
sc_sysIn.gl_VertexIndex=gl_VertexIndex;
sc_sysIn.gl_InstanceIndex=gl_InstanceIndex;
sc_VertOut sc_vertOut={};
float4 param=float4(sc_sysIn.sc_sysAttributes.position.xy,0.0,1.0);
sc_SetClipPosition(param,sc_sysIn,sc_vertOut.sc_sysOut,sc_set0,sc_set1);
return sc_vertOut;
}
} // VERTEX SHADER


namespace SNAP_FS {
struct userUniformsObj
{
float2 clipPlanes;
};
struct sc_Set2
{
texture2d<float> depthTexture [[id(2)]];
sampler depthTextureSmp [[id(10)]];
constant userUniformsObj* UserUniforms [[id(16)]];
};
struct sc_FragOut
{
float4 fragColor [[color(0)]];
};
struct sc_FragIn
{
sc_SysIn sc_sysIn;
};
float lray_readDepthTexture(thread const int2& screenPos,thread texture2d<float> depthTexture,thread sampler depthTextureSmp)
{
return depthTexture.read(uint2(screenPos),0).x;
}
fragment sc_FragOut main_frag(sc_FragIn sc_fragIn [[stage_in]],constant sc_Set0& sc_set0 [[buffer(0)]],constant sc_Set1& sc_set1 [[buffer(1)]],constant sc_Set2& sc_set2 [[buffer(2)]],float4 gl_FragCoord [[position]],bool gl_FrontFacing [[front_facing]])
{
sc_fragIn.sc_sysIn.gl_FragCoord=gl_FragCoord;
sc_fragIn.sc_sysIn.gl_FrontFacing=gl_FrontFacing;
sc_FragOut sc_fragOut={};
int2 p=int2(sc_GetGlFragCoord(sc_fragIn.sc_sysIn,sc_set0,sc_set1).xy);
int2 param=p;
float depth=lray_readDepthTexture(param,sc_set2.depthTexture,sc_set2.depthTextureSmp);
if (depth==0.0)
{
sc_fragOut.fragColor=float4(0.0,1.0,0.0,1.0);
}
else
{
if (depth==1.0)
{
sc_fragOut.fragColor=float4(0.0,0.0,1.0,1.0);
}
else
{
float w=0.02;
float ld=w/((1.0+w)-depth);
sc_fragOut.fragColor=float4(ld,ld,ld,1.0);
}
}
return sc_fragOut;
}
} // FRAGMENT SHADER
