#pragma clang diagnostic ignored "-Wmissing-prototypes"
#include <metal_stdlib>
#include <simd/simd.h>
#include "std2_vs.metal"
#include "std2.metal"
using namespace metal;
//SG_REFLECTION_BEGIN(100)
//output uvec4 origin_and_mask 0
//output vec2 micro_normal 2
//output vec2 direction 1
//sampler sampler blueNoiseTextureSmp 2:8
//sampler sampler receivers0Smp 2:13
//sampler sampler receivers1Smp 2:14
//texture texture2D blueNoiseTexture 2:0:2:8
//texture utexture2D receivers0 2:5:2:13
//texture utexture2D receivers1 2:6:2:14
//ubo float UserUniforms 2:16:8 {
//float sin_of_pixel_half_angle 0
//float force_mirror_refl 4
//}
//SG_REFLECTION_END

namespace SNAP_VS {
struct userUniformsObj
{
float sin_of_pixel_half_angle;
float force_mirror_refl;
};
struct sc_Set2
{
texture2d<float> blueNoiseTexture [[id(0)]];
texture2d<uint> receivers0 [[id(5)]];
texture2d<uint> receivers1 [[id(6)]];
sampler blueNoiseTextureSmp [[id(8)]];
sampler receivers0Smp [[id(13)]];
sampler receivers1Smp [[id(14)]];
constant userUniformsObj* UserUniforms [[id(16)]];
};
struct sc_VertOut
{
sc_SysOut sc_sysOut;
};
struct sc_VertIn
{
sc_SysAttributes sc_sysAttributes;
};
vertex sc_VertOut main_vert(sc_VertIn sc_vertIn [[stage_in]],constant sc_Set0& sc_set0 [[buffer(0)]],constant sc_Set1& sc_set1 [[buffer(1)]],constant sc_Set2& sc_set2 [[buffer(2)]],uint gl_VertexIndex [[vertex_id]],uint gl_InstanceIndex [[instance_id]])
{
sc_SysIn sc_sysIn;
sc_sysIn.sc_sysAttributes=sc_vertIn.sc_sysAttributes;
sc_sysIn.gl_VertexIndex=gl_VertexIndex;
sc_sysIn.gl_InstanceIndex=gl_InstanceIndex;
sc_VertOut sc_vertOut={};
float4 param=float4(sc_sysIn.sc_sysAttributes.position.xy,0.0,1.0);
sc_SetClipPosition(param,sc_sysIn,sc_vertOut.sc_sysOut,sc_set0,sc_set1);
return sc_vertOut;
}
} // VERTEX SHADER


namespace SNAP_FS {
struct sample_output
{
float3 micro_normal;
float3 reflection_vector;
};
struct userUniformsObj
{
float sin_of_pixel_half_angle;
float force_mirror_refl;
};
struct sc_Set2
{
texture2d<float> blueNoiseTexture [[id(0)]];
texture2d<uint> receivers0 [[id(5)]];
texture2d<uint> receivers1 [[id(6)]];
sampler blueNoiseTextureSmp [[id(8)]];
sampler receivers0Smp [[id(13)]];
sampler receivers1Smp [[id(14)]];
constant userUniformsObj* UserUniforms [[id(16)]];
};
struct sc_FragOut
{
uint4 origin_and_mask [[color(0)]];
float2 direction [[color(1)]];
float2 micro_normal [[color(2)]];
};
struct sc_FragIn
{
sc_SysIn sc_sysIn;
};
uint4 lray_readReceivers0(thread const int2& screenPos,thread texture2d<uint> receivers0,thread sampler receivers0Smp)
{
return receivers0.read(uint2(screenPos),0);
}
uint4 lray_readReceivers1(thread const int2& screenPos,thread texture2d<uint> receivers1,thread sampler receivers1Smp)
{
return receivers1.read(uint2(screenPos),0);
}
float3 decode_normal(thread const float2& f)
{
float3 n=float3(f.x,f.y,(1.0-abs(f.x))-abs(f.y));
float t=fast::max(-n.z,0.0);
float l9_0;
if (n.x>=0.0)
{
l9_0=-t;
}
else
{
l9_0=t;
}
float l9_1=l9_0;
float l9_2;
if (n.y>=0.0)
{
l9_2=-t;
}
else
{
l9_2=t;
}
float2 l9_3=n.xy+float2(l9_1,l9_2);
n=float3(l9_3.x,l9_3.y,n.z);
return normalize(n);
}
float get_roughness(thread const float& w,constant userUniformsObj& UserUniforms)
{
if (UserUniforms.force_mirror_refl>0.0)
{
return 0.0;
}
return w*w;
}
bool IsMirrorReflection(thread const float& roughness)
{
return roughness<1e-05;
}
float2 encode_normal(thread float3& d)
{
float l1norm=dot(abs(d),float3(1.0));
d/=float3(l1norm);
float t=fast::clamp(-d.z,0.0,1.0);
float2 ret=d.xy;
float l9_0;
if (d.x>=0.0)
{
l9_0=t;
}
else
{
l9_0=-t;
}
ret.x+=l9_0;
float l9_1;
if (d.y>=0.0)
{
l9_1=t;
}
else
{
l9_1=-t;
}
ret.y+=l9_1;
return ret;
}
float3x3 CreateTBN(thread const float3& N)
{
float3 U;
if (abs(N.z)>0.0)
{
float k=sqrt((N.y*N.y)+(N.z*N.z));
U.x=0.0;
U.y=(-N.z)/k;
U.z=N.y/k;
}
else
{
float k_1=sqrt((N.x*N.x)+(N.y*N.y));
U.x=N.y/k_1;
U.y=(-N.x)/k_1;
U.z=0.0;
}
float3x3 TBN;
TBN[0]=U;
TBN[1]=cross(N,U);
TBN[2]=N;
return transpose(TBN);
}
float lray_readBlueNoiseTexture(thread const int2& screenPos,thread texture2d<float> blueNoiseTexture,thread sampler blueNoiseTextureSmp)
{
return blueNoiseTexture.read(uint2(screenPos),0).x;
}
float2 SampleRandomVector2(thread const int2& p,thread texture2d<float> blueNoiseTexture,thread sampler blueNoiseTextureSmp)
{
float temporalFactor=0.0;
int2 param=p%int2(128);
int2 param_1=(p%int2(128))+int2(0,128);
float2 u=fract(float2(lray_readBlueNoiseTexture(param,blueNoiseTexture,blueNoiseTextureSmp)+temporalFactor,lray_readBlueNoiseTexture(param_1,blueNoiseTexture,blueNoiseTextureSmp)+temporalFactor));
return u;
}
float3 sampleGGXVNDF(thread const float3& Ve,thread const float& alpha_x,thread const float& alpha_y,thread const float& U1,thread const float& U2)
{
float3 Vh=normalize(float3(alpha_x*Ve.x,alpha_y*Ve.y,Ve.z));
float lensq=(Vh.x*Vh.x)+(Vh.y*Vh.y);
float3 l9_0;
if (lensq>0.0)
{
l9_0=float3(-Vh.y,Vh.x,0.0)/float3(sqrt(lensq));
}
else
{
l9_0=float3(1.0,0.0,0.0);
}
float3 T1=l9_0;
float3 T2=cross(Vh,T1);
float r=sqrt(U1);
float phi=6.28319*U2;
float t1=r*cos(phi);
float t2=r*sin(phi);
float s=0.5*(1.0+Vh.z);
t2=((1.0-s)*sqrt(1.0-(t1*t1)))+(s*t2);
float3 Nh=((T1*t1)+(T2*t2))+(Vh*sqrt(fast::max(0.0,(1.0-(t1*t1))-(t2*t2))));
float3 Ne=normalize(float3(alpha_x*Nh.x,alpha_y*Nh.y,fast::max(0.0,Nh.z)));
return Ne;
}
float3 Sample_GGX_VNDF_Ellipsoid(thread const float3& Ve,thread const float& alpha_x,thread const float& alpha_y,thread const float& U1,thread const float& U2)
{
float3 param=Ve;
float param_1=alpha_x;
float param_2=alpha_y;
float param_3=U1;
float param_4=U2;
return sampleGGXVNDF(param,param_1,param_2,param_3,param_4);
}
float3 Sample_GGX_VNDF_Hemisphere(thread const float3& Ve,thread const float& alpha,thread const float& U1,thread const float& U2)
{
float3 param=Ve;
float param_1=alpha;
float param_2=alpha;
float param_3=U1;
float param_4=U2;
return Sample_GGX_VNDF_Ellipsoid(param,param_1,param_2,param_3,param_4);
}
sample_output SampleReflectionVector(thread const float3& view_direction,thread const float3& normal,thread const float& roughness,thread const int2& did,thread texture2d<float> blueNoiseTexture,thread sampler blueNoiseTextureSmp)
{
float3 param=normal;
float3x3 tbn_transform=CreateTBN(param);
float3 view_direction_tbn=tbn_transform*(-view_direction);
int2 param_1=did;
float2 u=SampleRandomVector2(param_1,blueNoiseTexture,blueNoiseTextureSmp);
u.x*=0.8;
float3 param_2=view_direction_tbn;
float param_3=roughness;
float param_4=u.x;
float param_5=u.y;
float3 sampled_normal_tbn=Sample_GGX_VNDF_Hemisphere(param_2,param_3,param_4,param_5);
float3 reflected_direction_tbn=reflect(-view_direction_tbn,sampled_normal_tbn);
float3x3 inv_tbn_transform=transpose(tbn_transform);
sample_output out_data;
out_data.reflection_vector=inv_tbn_transform*reflected_direction_tbn;
out_data.micro_normal=normalize(inv_tbn_transform*sampled_normal_tbn);
return out_data;
}
fragment sc_FragOut main_frag(sc_FragIn sc_fragIn [[stage_in]],constant sc_Set0& sc_set0 [[buffer(0)]],constant sc_Set1& sc_set1 [[buffer(1)]],constant sc_Set2& sc_set2 [[buffer(2)]],float4 gl_FragCoord [[position]],bool gl_FrontFacing [[front_facing]])
{
sc_fragIn.sc_sysIn.gl_FragCoord=gl_FragCoord;
sc_fragIn.sc_sysIn.gl_FrontFacing=gl_FrontFacing;
sc_FragOut sc_fragOut={};
int2 p=int2(sc_GetGlFragCoord(sc_fragIn.sc_sysIn,sc_set0,sc_set1).xy);
int2 param=p;
uint4 rec0u=lray_readReceivers0(param,sc_set2.receivers0,sc_set2.receivers0Smp);
int2 param_1=p;
uint4 rec1u=lray_readReceivers1(param_1,sc_set2.receivers1,sc_set2.receivers1Smp);
float4 rec1=float4(float2(as_type<half2>(rec1u.x)).x,float2(as_type<half2>(rec1u.y)).x,float2(as_type<half2>(rec1u.z)).x,float2(as_type<half2>(rec1u.w)).x);
float3 position=(float3(rec0u.xyz)*(*sc_set0.LibraryUniforms).OriginNormalizationScaleInv)+(*sc_set0.LibraryUniforms).OriginNormalizationOffset;
float2 param_2=rec1.xy;
float3 normal=decode_normal(param_2);
float3 origin=position+float3(normal*0.01);
uint3 l9_0=uint3((origin-(*sc_set0.LibraryUniforms).OriginNormalizationOffset)*(*sc_set0.LibraryUniforms).OriginNormalizationScale);
sc_fragOut.origin_and_mask=uint4(l9_0.x,l9_0.y,l9_0.z,sc_fragOut.origin_and_mask.w);
sc_fragOut.origin_and_mask.w=rec0u.w;
float param_3=rec1.w;
float roughness=get_roughness(param_3,(*sc_set2.UserUniforms));
float3 view=normalize(position-(*sc_set0.LibraryUniforms).sc_Camera.position);
float param_4=roughness;
float3 dir;
if (IsMirrorReflection(param_4))
{
dir=reflect(view,normal);
float3 param_5=normal;
float2 l9_1=encode_normal(param_5);
sc_fragOut.micro_normal=l9_1;
}
else
{
float3 param_6=view;
float3 param_7=normal;
float param_8=roughness;
int2 param_9=p;
sample_output sample_out=SampleReflectionVector(param_6,param_7,param_8,param_9,sc_set2.blueNoiseTexture,sc_set2.blueNoiseTextureSmp);
dir=normalize(sample_out.reflection_vector);
float3 param_10=sample_out.micro_normal;
float2 l9_2=encode_normal(param_10);
sc_fragOut.micro_normal=l9_2;
}
float3 param_11=dir;
float2 l9_3=encode_normal(param_11);
sc_fragOut.direction=l9_3;
return sc_fragOut;
}
} // FRAGMENT SHADER
