#pragma clang diagnostic ignored "-Wmissing-prototypes"
#include <metal_stdlib>
#include <simd/simd.h>
#include "std2.metal"
#include "std2_vs.metal"
using namespace metal;
//SG_REFLECTION_BEGIN(100)
//output vec4 outColor 0
//sampler sampler colorInputSmp 2:9
//sampler sampler receivers0Smp 2:13
//sampler sampler receivers1Smp 2:14
//sampler sampler searchParamResultsSmp 2:15
//texture texture2D colorInput 2:1:2:9
//texture utexture2D receivers0 2:5:2:13
//texture utexture2D receivers1 2:6:2:14
//texture texture2D searchParamResults 2:7:2:15
//ubo float UserUniforms 2:16:16 {
//float roughness_power 0
//float2 kernel_mask 8
//}
//SG_REFLECTION_END

namespace SNAP_VS {
#ifndef DEBUG_GLOSSY_KERNEL
#define DEBUG_GLOSSY_KERNEL 0
#elif DEBUG_GLOSSY_KERNEL==1
#undef DEBUG_GLOSSY_KERNEL
#define DEBUG_GLOSSY_KERNEL 1
#endif
struct userUniformsObj
{
float roughness_power;
float2 kernel_mask;
};
struct sc_Set2
{
texture2d<float> colorInput [[id(1)]];
texture2d<uint> receivers0 [[id(5)]];
texture2d<uint> receivers1 [[id(6)]];
texture2d<float> searchParamResults [[id(7)]];
sampler colorInputSmp [[id(9)]];
sampler receivers0Smp [[id(13)]];
sampler receivers1Smp [[id(14)]];
sampler searchParamResultsSmp [[id(15)]];
constant userUniformsObj* UserUniforms [[id(16)]];
};
struct sc_VertOut
{
sc_SysOut sc_sysOut;
};
struct sc_VertIn
{
sc_SysAttributes sc_sysAttributes;
};
vertex sc_VertOut main_vert(sc_VertIn sc_vertIn [[stage_in]],constant sc_Set0& sc_set0 [[buffer(0)]],constant sc_Set1& sc_set1 [[buffer(1)]],constant sc_Set2& sc_set2 [[buffer(2)]],uint gl_VertexIndex [[vertex_id]],uint gl_InstanceIndex [[instance_id]])
{
sc_SysIn sc_sysIn;
sc_sysIn.sc_sysAttributes=sc_vertIn.sc_sysAttributes;
sc_sysIn.gl_VertexIndex=gl_VertexIndex;
sc_sysIn.gl_InstanceIndex=gl_InstanceIndex;
sc_VertOut sc_vertOut={};
float4 param=float4(sc_sysIn.sc_sysAttributes.position.xy,-1.0,1.0);
sc_SetClipPosition(param,sc_sysIn,sc_vertOut.sc_sysOut,sc_set0,sc_set1);
return sc_vertOut;
}
} // VERTEX SHADER


namespace SNAP_FS {
struct userUniformsObj
{
float roughness_power;
float2 kernel_mask;
};
#ifndef DEBUG_GLOSSY_KERNEL
#define DEBUG_GLOSSY_KERNEL 0
#elif DEBUG_GLOSSY_KERNEL==1
#undef DEBUG_GLOSSY_KERNEL
#define DEBUG_GLOSSY_KERNEL 1
#endif
struct sc_Set2
{
texture2d<float> colorInput [[id(1)]];
texture2d<uint> receivers0 [[id(5)]];
texture2d<uint> receivers1 [[id(6)]];
texture2d<float> searchParamResults [[id(7)]];
sampler colorInputSmp [[id(9)]];
sampler receivers0Smp [[id(13)]];
sampler receivers1Smp [[id(14)]];
sampler searchParamResultsSmp [[id(15)]];
constant userUniformsObj* UserUniforms [[id(16)]];
};
struct sc_FragOut
{
float4 outColor [[color(0)]];
};
struct sc_FragIn
{
sc_SysIn sc_sysIn;
};
float2 lray_readSearchParamResults(thread const int2& screenPos,thread texture2d<float> searchParamResults,thread sampler searchParamResultsSmp)
{
return searchParamResults.read(uint2(screenPos),0).xy;
}
float3 get_debug_color(thread const float& kernel0)
{
float max_samples=21.0;
float t=kernel0/max_samples;
bool no_blur=kernel0<0.0001;
return float3(kernel0/255.0);
}
float4 lray_readColorInput(thread const int2& screenPos,thread texture2d<float> colorInput,thread sampler colorInputSmp)
{
return colorInput.read(uint2(screenPos),0);
}
float4 get_image(thread const int2& p,thread texture2d<float> colorInput,thread sampler colorInputSmp)
{
int2 param=p;
return fast::clamp(lray_readColorInput(param,colorInput,colorInputSmp),float4(0.0),float4(10000.0));
}
uint4 lray_readReceivers0(thread const int2& screenPos,thread texture2d<uint> receivers0,thread sampler receivers0Smp)
{
return receivers0.read(uint2(screenPos),0);
}
float3 get_worldPos(thread const int2& p,thread texture2d<uint> receivers0,thread sampler receivers0Smp,thread sc_SysIn& sc_sysIn,const constant sc_Set0& sc_set0,const constant sc_Set1& sc_set1)
{
int2 param=p;
uint4 rec0u=lray_readReceivers0(param,receivers0,receivers0Smp);
return (float3(rec0u.xyz)*(*sc_set0.LibraryUniforms).OriginNormalizationScaleInv)+(*sc_set0.LibraryUniforms).OriginNormalizationOffset;
}
uint4 lray_readReceivers1(thread const int2& screenPos,thread texture2d<uint> receivers1,thread sampler receivers1Smp)
{
return receivers1.read(uint2(screenPos),0);
}
float3 decode_normal(thread const float2& f)
{
float3 n=float3(f.x,f.y,(1.0-abs(f.x))-abs(f.y));
float t=fast::max(-n.z,0.0);
float l9_0;
if (n.x>=0.0)
{
l9_0=-t;
}
else
{
l9_0=t;
}
float l9_1=l9_0;
float l9_2;
if (n.y>=0.0)
{
l9_2=-t;
}
else
{
l9_2=t;
}
float2 l9_3=n.xy+float2(l9_1,l9_2);
n=float3(l9_3.x,l9_3.y,n.z);
return normalize(n);
}
float3 get_normal(thread const int2& p,thread texture2d<uint> receivers1,thread sampler receivers1Smp)
{
int2 param=p;
uint4 rec1u=lray_readReceivers1(param,receivers1,receivers1Smp);
float2 param_1=float2(float2(as_type<half2>(rec1u.x)).x,float2(as_type<half2>(rec1u.y)).x);
return decode_normal(param_1);
}
float4 gather(thread const int2& p,thread float2& kernel0,thread const float& coverageWS,thread texture2d<uint> receivers0,thread sampler receivers0Smp,thread texture2d<uint> receivers1,thread sampler receivers1Smp,thread texture2d<float> colorInput,thread sampler colorInputSmp,thread sc_SysIn& sc_sysIn,const constant sc_Set0& sc_set0,const constant sc_Set1& sc_set1)
{
int2 param=p;
float3 pWS=get_worldPos(param,receivers0,receivers0Smp,sc_sysIn,sc_set0,sc_set1);
int2 param_1=p;
float3 nWS=get_normal(param_1,receivers1,receivers1Smp);
float4 numerator=float4(0.0);
float denominator=0.0001;
kernel0=ceil(kernel0);
kernel0-=(float2(1.0)-float2(int2(kernel0)%int2(2)));
kernel0=fast::clamp(kernel0,float2(0.0),float2(255.0));
int2 unit=int2(fast::clamp(kernel0,float2(0.0),float2(1.0)));
int i=0;
for (int snapLoopIndex=0; snapLoopIndex==0; snapLoopIndex+=0)
{
if (i<int(fast::max(kernel0.x,kernel0.y)))
{
int2 pi=(p-int2(floor(kernel0/float2(2.0))))+(int2(i)*unit);
int2 param_2=pi;
float3 Ni=get_normal(param_2,receivers1,receivers1Smp);
if (length(Ni)<0.0001)
{
i++;
continue;
}
int2 param_3=pi;
float fl=length(pWS-get_worldPos(param_3,receivers0,receivers0Smp,sc_sysIn,sc_set0,sc_set1));
float fn=1.0-dot(nWS,Ni);
float distFactor=(((-fl)*fl)*5.0)/coverageWS;
float normalFactor=((-fn)*fn)*5.0;
float r=pow(2.71828,distFactor+normalFactor);
denominator+=r;
int2 param_4=pi;
float4 c=get_image(param_4,colorInput,colorInputSmp);
float3 l9_0=numerator.xyz+(c.xyz*(r*c.w));
numerator=float4(l9_0.x,l9_0.y,l9_0.z,numerator.w);
numerator.w+=(r*c.w);
i++;
continue;
}
else
{
break;
}
}
float4 col=numerator/float4(denominator);
float4 l9_1;
if (col.w<0.01)
{
l9_1=float4(0.0);
}
else
{
l9_1=float4(col.xyz/float3(col.w),col.w);
}
return l9_1;
}
fragment sc_FragOut main_frag(sc_FragIn sc_fragIn [[stage_in]],constant sc_Set0& sc_set0 [[buffer(0)]],constant sc_Set1& sc_set1 [[buffer(1)]],constant sc_Set2& sc_set2 [[buffer(2)]],float4 gl_FragCoord [[position]],bool gl_FrontFacing [[front_facing]])
{
sc_fragIn.sc_sysIn.gl_FragCoord=gl_FragCoord;
sc_fragIn.sc_sysIn.gl_FrontFacing=gl_FrontFacing;
sc_FragOut sc_fragOut={};
int2 p=int2(sc_GetGlFragCoord(sc_fragIn.sc_sysIn,sc_set0,sc_set1).xy);
int2 param=p;
float2 resultPS=lray_readSearchParamResults(param,sc_set2.searchParamResults,sc_set2.searchParamResultsSmp)*255.0;
float kernel0=resultPS.x;
#if (DEBUG_GLOSSY_KERNEL)
{
float param_1=kernel0;
sc_fragOut.outColor=float4(get_debug_color(param_1),1.0);
}
#else
{
if (kernel0==0.0)
{
int2 param_2=p;
sc_fragOut.outColor=get_image(param_2,sc_set2.colorInput,sc_set2.colorInputSmp);
}
else
{
int2 param_3=p;
float2 param_4=(*sc_set2.UserUniforms).kernel_mask*kernel0;
float param_5=resultPS.y;
float4 l9_0=gather(param_3,param_4,param_5,sc_set2.receivers0,sc_set2.receivers0Smp,sc_set2.receivers1,sc_set2.receivers1Smp,sc_set2.colorInput,sc_set2.colorInputSmp,sc_fragIn.sc_sysIn,sc_set0,sc_set1);
sc_fragOut.outColor=l9_0;
}
}
#endif
return sc_fragOut;
}
} // FRAGMENT SHADER
