#pragma clang diagnostic ignored "-Wmissing-prototypes"
#include <metal_stdlib>
#include <simd/simd.h>
#include "std2_vs.metal"
#include "required2.metal"
using namespace metal;
//SG_REFLECTION_BEGIN(100)
//output vec2 outParam 0
//sampler sampler hitDistanceSmp 2:11
//sampler sampler receivers0Smp 2:13
//sampler sampler receivers1Smp 2:14
//texture utexture2D hitDistance 2:3:2:11
//texture utexture2D receivers0 2:5:2:13
//texture utexture2D receivers1 2:6:2:14
//ubo float UserUniforms 2:16:20 {
//float roughness_power 0
//float distanceNormalizationScale 4
//float scene_dimensions 8
//float max_distance 12
//float harden 16
//}
//SG_REFLECTION_END

namespace SNAP_VS {
struct userUniformsObj
{
float roughness_power;
float distanceNormalizationScale;
float scene_dimensions;
float max_distance;
float harden;
};
struct sc_Set2
{
texture2d<uint> hitDistance [[id(3)]];
texture2d<uint> receivers0 [[id(5)]];
texture2d<uint> receivers1 [[id(6)]];
sampler hitDistanceSmp [[id(11)]];
sampler receivers0Smp [[id(13)]];
sampler receivers1Smp [[id(14)]];
constant userUniformsObj* UserUniforms [[id(16)]];
};
constant int2 g9_50[33]={ int2(0),int2(0,1),int2(0,-1),int2(-1,0),int2(1,0),int2(-1),int2(1),int2(-1,1),int2(1,-1),int2(2,-2),int2(-2,2),int2(2),int2(-2),int2(-3,-1),int2(-1,-3),int2(1,-3),int2(3,-1),int2(3,1),int2(1,3),int2(-1,3),int2(-3,1),int2(-2,-4),int2(0,-4),int2(2,-4),int2(-2,4),int2(0,4),int2(2,4),int2(-4,-2),int2(-4,0),int2(-4,2),int2(4,-2),int2(4,0),int2(4,2) };
struct sc_VertOut
{
sc_SysOut sc_sysOut;
};
struct sc_VertIn
{
sc_SysAttributes sc_sysAttributes;
};
vertex sc_VertOut main_vert(sc_VertIn sc_vertIn [[stage_in]],constant sc_Set0& sc_set0 [[buffer(0)]],constant sc_Set1& sc_set1 [[buffer(1)]],constant sc_Set2& sc_set2 [[buffer(2)]],uint gl_VertexIndex [[vertex_id]],uint gl_InstanceIndex [[instance_id]])
{
sc_SysIn sc_sysIn;
sc_sysIn.sc_sysAttributes=sc_vertIn.sc_sysAttributes;
sc_sysIn.gl_VertexIndex=gl_VertexIndex;
sc_sysIn.gl_InstanceIndex=gl_InstanceIndex;
sc_VertOut sc_vertOut={};
float4 param=float4(sc_sysIn.sc_sysAttributes.position.xy,-1.0,1.0);
sc_SetClipPosition(param,sc_sysIn,sc_vertOut.sc_sysOut,sc_set0,sc_set1);
return sc_vertOut;
}
} // VERTEX SHADER


namespace SNAP_FS {
struct userUniformsObj
{
float roughness_power;
float distanceNormalizationScale;
float scene_dimensions;
float max_distance;
float harden;
};
struct sc_Set2
{
texture2d<uint> hitDistance [[id(3)]];
texture2d<uint> receivers0 [[id(5)]];
texture2d<uint> receivers1 [[id(6)]];
sampler hitDistanceSmp [[id(11)]];
sampler receivers0Smp [[id(13)]];
sampler receivers1Smp [[id(14)]];
constant userUniformsObj* UserUniforms [[id(16)]];
};
constant int2 g9_21[33]={ int2(0),int2(0,1),int2(0,-1),int2(-1,0),int2(1,0),int2(-1),int2(1),int2(-1,1),int2(1,-1),int2(2,-2),int2(-2,2),int2(2),int2(-2),int2(-3,-1),int2(-1,-3),int2(1,-3),int2(3,-1),int2(3,1),int2(1,3),int2(-1,3),int2(-3,1),int2(-2,-4),int2(0,-4),int2(2,-4),int2(-2,4),int2(0,4),int2(2,4),int2(-4,-2),int2(-4,0),int2(-4,2),int2(4,-2),int2(4,0),int2(4,2) };
struct sc_FragOut
{
float2 outParam [[color(0)]];
};
struct sc_FragIn
{
sc_SysIn sc_sysIn;
};
uint4 lray_readReceivers1(thread const int2& screenPos,thread texture2d<uint> receivers1,thread sampler receivers1Smp)
{
return receivers1.read(uint2(screenPos),0);
}
float get_roughness(thread const int2& p,thread texture2d<uint> receivers1,thread sampler receivers1Smp)
{
int2 param=p;
float r=float2(as_type<half2>(lray_readReceivers1(param,receivers1,receivers1Smp).w)).x;
return r;
}
uint4 lray_readReceivers0(thread const int2& screenPos,thread texture2d<uint> receivers0,thread sampler receivers0Smp)
{
return receivers0.read(uint2(screenPos),0);
}
float3 get_worldPos(thread const int2& p,thread texture2d<uint> receivers0,thread sampler receivers0Smp,thread sc_SysIn& sc_sysIn,const constant sc_Set0& sc_set0,const constant sc_Set1& sc_set1)
{
int2 param=p;
uint4 rec0u=lray_readReceivers0(param,receivers0,receivers0Smp);
return (float3(rec0u.xyz)*(*sc_set0.LibraryUniforms).OriginNormalizationScaleInv)+(*sc_set0.LibraryUniforms).OriginNormalizationOffset;
}
float3 decode_normal(thread const float2& f)
{
float3 n=float3(f.x,f.y,(1.0-abs(f.x))-abs(f.y));
float t=fast::max(-n.z,0.0);
float l9_0;
if (n.x>=0.0)
{
l9_0=-t;
}
else
{
l9_0=t;
}
float l9_1=l9_0;
float l9_2;
if (n.y>=0.0)
{
l9_2=-t;
}
else
{
l9_2=t;
}
float2 l9_3=n.xy+float2(l9_1,l9_2);
n=float3(l9_3.x,l9_3.y,n.z);
return normalize(n);
}
float3 get_normal(thread const int2& p,thread texture2d<uint> receivers1,thread sampler receivers1Smp)
{
int2 param=p;
uint4 rec1u=lray_readReceivers1(param,receivers1,receivers1Smp);
float2 param_1=float2(float2(as_type<half2>(rec1u.x)).x,float2(as_type<half2>(rec1u.y)).x);
return decode_normal(param_1);
}
uint lray_readHitDistance(thread const int2& screenPos,thread texture2d<uint> hitDistance,thread sampler hitDistanceSmp)
{
return hitDistance.read(uint2(screenPos),0).x;
}
float get_normalized_distance(thread const int2& p,thread texture2d<uint> hitDistance,thread sampler hitDistanceSmp,constant userUniformsObj& UserUniforms)
{
int2 param=p;
uint raw_dist=lray_readHitDistance(param,hitDistance,hitDistanceSmp);
if (raw_dist==4294967295u)
{
return 1.0;
}
float dist=float(raw_dist)/UserUniforms.distanceNormalizationScale;
float d=fast::clamp(dist/UserUniforms.max_distance,0.0,1.0);
return d;
}
float2 parameter_search(thread const int2& p,thread texture2d<uint> receivers0,thread sampler receivers0Smp,thread texture2d<uint> receivers1,thread sampler receivers1Smp,thread texture2d<uint> hitDistance,thread sampler hitDistanceSmp,constant userUniformsObj& UserUniforms,thread sc_SysIn& sc_sysIn,const constant sc_Set0& sc_set0,const constant sc_Set1& sc_set1)
{
float2 retVal=float2(0.0);
float numerator=0.0;
float denominator=0.0;
int2 param=p;
float3 pos0=get_worldPos(param,receivers0,receivers0Smp,sc_sysIn,sc_set0,sc_set1);
int2 param_1=p;
float3 normal0=get_normal(param_1,receivers1,receivers1Smp);
int2 param_2=p;
float dist0=get_normalized_distance(param_2,hitDistance,hitDistanceSmp,UserUniforms);
retVal.y=0.00116012*length(pos0-(*sc_set0.LibraryUniforms).sc_Camera.position);
float retValue=0.0;
int i=0;
for (int snapLoopIndex=0; snapLoopIndex==0; snapLoopIndex+=0)
{
if (i<33)
{
int2 pi=p+g9_21[i];
int2 param_3=pi;
float3 piNormal=get_normal(param_3,receivers1,receivers1Smp);
if (length(piNormal)<0.0001)
{
i++;
continue;
}
int2 param_4=pi;
float l=length(pos0-get_worldPos(param_4,receivers0,receivers0Smp,sc_sysIn,sc_set0,sc_set1));
int2 param_5=pi;
float n=1.0-dot(normal0,get_normal(param_5,receivers1,receivers1Smp));
float r=pow(2.71828,(((-l)*l)*5.0)-((n*n)*5.0));
int2 param_6=pi;
float dist=get_normalized_distance(param_6,hitDistance,hitDistanceSmp,UserUniforms);
numerator+=(r*dist);
denominator+=r;
i++;
continue;
}
else
{
break;
}
}
if (denominator<0.0001)
{
retVal.x=1.0;
}
else
{
retVal.x=numerator/denominator;
}
return retVal;
}
float2 get_kernel(thread const float& search_param_result,thread const float& pixelWidth,thread const float& roughness,constant userUniformsObj& UserUniforms)
{
float d=search_param_result*UserUniforms.scene_dimensions;
float coverage=(2.0*d)*tan((0.436332*roughness)/2.0);
return float2(fast::clamp(coverage/pixelWidth,3.0,55.0),fast::clamp(coverage,1.0,255.0));
}
fragment sc_FragOut main_frag(sc_FragIn sc_fragIn [[stage_in]],constant sc_Set0& sc_set0 [[buffer(0)]],constant sc_Set1& sc_set1 [[buffer(1)]],constant sc_Set2& sc_set2 [[buffer(2)]],float4 gl_FragCoord [[position]],bool gl_FrontFacing [[front_facing]])
{
sc_fragIn.sc_sysIn.gl_FragCoord=gl_FragCoord;
sc_fragIn.sc_sysIn.gl_FrontFacing=gl_FrontFacing;
sc_FragOut sc_fragOut={};
int2 p=int2(sc_GetGlFragCoord(sc_fragIn.sc_sysIn,sc_set0,sc_set1).xy);
int2 param=p;
float roughness=get_roughness(param,sc_set2.receivers1,sc_set2.receivers1Smp);
if (roughness==0.0)
{
sc_fragOut.outParam=float2(0.0);
}
else
{
int2 param_1=p;
float2 result=parameter_search(param_1,sc_set2.receivers0,sc_set2.receivers0Smp,sc_set2.receivers1,sc_set2.receivers1Smp,sc_set2.hitDistance,sc_set2.hitDistanceSmp,(*sc_set2.UserUniforms),sc_fragIn.sc_sysIn,sc_set0,sc_set1);
result.x=mix(result.x,result.x*result.x,(*sc_set2.UserUniforms).harden);
if ((*sc_set2.UserUniforms).roughness_power>0.1)
{
roughness=pow(roughness,(*sc_set2.UserUniforms).roughness_power);
}
float param_2=result.x;
float param_3=result.y;
float param_4=roughness;
sc_fragOut.outParam=get_kernel(param_2,param_3,param_4,(*sc_set2.UserUniforms))/float2(255.0);
}
return sc_fragOut;
}
} // FRAGMENT SHADER
